#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = __importDefault(require("commander"));
var glob_1 = __importDefault(require("glob"));
var convertToPlant_1 = require("./convertToPlant");
var generateDocumentation_1 = require("./generateDocumentation");
commander_1.default
    .version('2.0.4')
    .usage('[options]')
    .option('-i, --input [string]', 'input file')
    .parse(process.argv);
if (!commander_1.default.input) {
    console.error('missing input file');
    process.exit(1);
}
glob_1.default(commander_1.default.input, {}, function (err, matches) {
    if (err !== null) {
        console.error(err);
        return;
    }
    console.log(convertToPlant_1.convertToPlant(generateDocumentation_1.generateDocumentation(matches)));
});
